<?php

class viruscheck extends IncludableSpecialPage {
	/**
	 * Constructor
	 */
	public function __construct() {
		parent::__construct( 'viruscheck' );
	}

	/**
	 * Show the special page
	 *
	 * @param string|null $par User name, optionally followed by a namespace, or null
	 */
	public function execute( $par ) {
		global $wgContLang;

		$target = isset( $par ) ? $par : $this->getRequest()->getText( 'url' );
$out = $this->getOutput();
		$this->setHeaders();
$virustotal_api_key = 'この部分は変更してください';
$scan_url = $target;
 
$post = array('apikey' => $virustotal_api_key,'url'=> $scan_url);
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, 'https://www.virustotal.com/vtapi/v2/url/scan');
curl_setopt($ch, CURLOPT_POST, True);
curl_setopt($ch, CURLOPT_VERBOSE, 1); // remove this if your not debugging
curl_setopt($ch, CURLOPT_RETURNTRANSFER ,True);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
 
$result=curl_exec ($ch);
$status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
//print("status = $status_code\n");
if ($status_code == 200) { // OK
  $js = json_decode($result, true);
  
} else {  // Error occured
  print($result);
}
curl_close ($ch);
	$api_key = getenv('VT_API_KEY') ? getenv('VT_API_KEY') :'この部分は変更してください';
$scan_url =$target;
 
$post = array('apikey' => $api_key,'resource'=> $scan_url);
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, 'https://www.virustotal.com/vtapi/v2/url/report');
curl_setopt($ch, CURLOPT_POST, True);
curl_setopt($ch, CURLOPT_VERBOSE, 1); // remove this if your not debugging
curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate'); // please compress data
curl_setopt($ch, CURLOPT_USERAGENT, "gzip, My php curl client");
curl_setopt($ch, CURLOPT_RETURNTRANSFER ,True);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
 
$result=curl_exec ($ch);
$status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
//print("status = $status_code\n");
if ($status_code == 200) { // OK
  $js = json_decode($result, true);
$scans=$js["scans"];
$d=0;
foreach($scans as $k => $v){
if($v["detected"]){
$d++;
}
}
$per=$d*100/$js["total"];
if($per>50){
$out->addWikiText('['.$target.' '.$target.']<span style="background-color:red;width:10px;height:10px;">　</span>');
}else{
if($per>0){
$out->addWikiText('['.$target.' '.$target.']<span style="background-color:yellow;width:10px;height:10px;">　</span>');
}else{
$out->addWikiText('['.$target.' '.$target.']<span style="background-color:green;width:10px;height:10px;">　</span>');
}}
} else {  // Error occured
  $out->addWikiText('['.$target.' '.$target.']<span style="background-color:gray;width:10px;height:10px;">　</span>');
}
curl_close ($ch);	
	}

	/**
	 * Parse the username and namespace parts of the input and return them
	 *
	 * @access private
	 *
	 * @param string $par
	 * @return array
	 */
	function extractParamaters( $par ) {
		global $wgContLang;

		// @fixme don't use @
		@list( $user, $namespace ) = explode( '/', $par, 2 );

		// str*cmp sucks
		if ( isset( $namespace ) ) {
			$namespace = $wgContLang->getNsIndex( $namespace );
		}

		return array( $user, $namespace );
	}

	


	

}
?>
